/* sigwrapper.h
**
** a set of macros which install a wrapper around signal handlers which try
** to simulate the `System V'-behaviour of signal handling on a BSD-system.
*/
#ifndef _SIGWRAPPER_H
#define _SIGWRAPPER_H

#define BSD 1
#define SYSV 2

/* Operating system dependant part of the signal wrapper definitions... */
#if SIGTYPE == BSD
/* Define wrappers for simulating the `System V'-semantics on a BSD-system */
#   define SIGNAL(snum, shndl) signal ((snum), shndl ## _wrapper)
#   define SIGWRP(shndl) \
	void shndl(int snum); \
	static void shndl ## _wrapper (int snum) { \
	    signal (snum, SIG_DFL); \
	    shndl (snum); \
	}
#else
/* No wrapper-definition required - as `System V'-semantics is the default */
#   define SIGNAL(snum, shndl) signal ((snum), shndl)
#   define SIGWRP(shndl) void shndl(int snum);
#endif

/**/
#define SIGRST(snum) signal ((snum), SIG_DFL)

#endif /* defined(_SIGWRAPPER_H) */
